module Mashery
  class RestClient
    def build_url(query_params)
      Query.new(query_params).url
    end

    def call(activity_type, service_id, options)
      if activity_type == "developer_activity"
        query_options = {service_id: service_id, resource: "developer_activity"}.merge(options)
        query         = Query.new(query_options)
        perform_query(query)
      elsif activity_type == "errorcodes"
        query_options = {service_id: service_id, resource: "errorcodes"}.merge(options)
        query         = Query.new(query_options)
        perform_query(query)
      else
        raise "No such activity type!"
      end
    end

    def perform_query(query)
      response = ::RestClient.get(query.url)

      if query.format == "json" or query.format == "csv"
        response
      else
        raise UnknownFormat.new(query.format)
      end
    end
  end
end
