module Mashery
  class Service < RpcClient::Base
    attribute :service_key,  String
    attribute :name,         String
    attribute :limits,       Hash
    attribute :created,      DateTime
    attribute :updated,      DateTime
    attribute :object_type,  String

    def activity(options = {})
      Mashery.rest.call("developer_activity", service_key, {
        # TODO: For API purposes, these values probably shouldn't be hard-coded
        start_date: 1.day.ago, end_date: 0.days.ago
      }.merge(options))
    end

    def errorcodes(options = {})
      Mashery.rest.call("errorcodes", service_key, {
        # TODO: For API purposes, these values probably shouldn't be hard-coded
        start_date: 1.day.ago, end_date: 0.days.ago
      }.merge(options))
    end
  end
end
